#!/bin/bash

#ipregex
regex="\b(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\b"
#whotelist
voz_ip1="\b((193)\.(22)\.(119)\.)\b"
voz_ip2="\b((127)\.(0)\.(0)\.(1))\b"
voz_ip3="\b((217)\.(18)\.(237)\.)\b"
voz_ip4="\b((178)\.(23)\.(212)\.)\b"
voz_ip5="\b((176)\.(28)\.(89)\.)\b"
voz_ip6="\b((193)\.(238)\.(52)\.)\b"

logfile=/home/honeypot/HoneyPy/log/ipstoblock.log
banfile=/home/honeypot/HoneyPy/log/blockedips.log
honeypylog=/home/honeypot/HoneyPy/log/honeypyblocks.log
DATE=`date +%s`
DATELOG=`date '+%Y-%m-%d %H:%M:%S,%N'`
FILTERED=""

if [ -f $logfile ]; then
  for i in `cat $logfile | awk  '{print $2}' | sort | uniq`; do
    TMP_IP=`echo $i | awk -F ":" '{print $2}'`
    IP=$(echo $TMP_IP | egrep $regex | egrep -v $voz_ip1 | egrep -v $voz_ip2 | egrep -v $voz_ip3 | egrep -v $voz_ip4| egrep -v $voz_ip5| egrep -v $voz_ip6)
         if [ "$IP" != "" ]; then
            if [ -f $banfile ]; then
                FILTERED=`grep $IP $banfile`
            fi
            if [ "$FILTERED" == "" ]; then
                IPMAS="network "$IP"/32"
                /usr/bin/vtysh -c 'config term' -c 'router bgp 7675' -c "$IPMAS" -c exit -c exit
                echo "$DATELOG IP: ${IP}/32 blocked using BGP" >> $honeypylog
                echo $IP $DATE >> $banfile
            fi
         fi
  done

  rm $logfile
fi

# Delete old IPs from BGP
if [ -f $banfile ]; then
  touch /home/honeypot/HoneyPy/log/blockedips.tmp
  while read line
  do
    IP=`echo $line | awk -F" " '{print $1}'`
    START=`echo $line | awk -F" " '{print $2}'`
    ELAPSED=`expr $DATE - $START`
    if [ "$ELAPSED" -gt "7200" ]; then
         IPMAS="no network "$IP"/32"
         /usr/bin/vtysh -c 'config term' -c 'router bgp 7675' -c "$IPMAS" -c exit -c exit
         echo "$DATELOG IP: ${IP}/32 unblocked using BGP" >> $honeypylog
    else
      echo $line >> /home/honeypot/HoneyPy/log/blockedips.tmp
    fi
  done < $banfile

  if [ -f /home/honeypot/HoneyPy/log/blockedips.tmp ]; then
    mv /home/honeypot/HoneyPy/log/blockedips.tmp $banfile
  fi
fi
