#!/usr/bin/env python
# -*- coding: utf-8 -*-

from libnmap.parser import NmapParser
import MySQLdb
import smtplib
import pprint
import os
import time
from email.MIMEText import MIMEText
from email.MIMEMultipart import MIMEMultipart
from email.MIMEBase import MIMEBase
from email.Utils import COMMASPACE, formatdate
from email import Encoders


def check_opened_ports(nmap_report):
    notAllowed = dict()
    db=MySQLdb.connect("localhost","vtscanner","XXXXXXXXX","vt-port-scanning")
    c=db.cursor()
    
    for scanned_hosts in nmap_report.hosts:
        for port in scanned_hosts.get_open_ports():
            c.execute("""select h.ip from hosts h join host_ports hp on h.host_type_id = hp.host_type_id join type_ports p on p.port_type_id=hp.port_type_id where  (%s BETWEEN port_min and port_max) AND ip=%s AND proto=%s""", (port[0], scanned_hosts.address, port[1]))
            registro = c.fetchone()
            if registro == None:
               if(notAllowed.has_key(scanned_hosts.address)):
                  notAllowed[scanned_hosts.address].append(port)
               else:
                  notAllowed[scanned_hosts.address] = [port]
    
    if notAllowed:
      msg_text = """\
       <html>
         <head></head>
         <body>
      """
      msg_text += "<center><h1>Se han detectado puertos abiertos no controlados.</h1></center></br><center><h2>Fecha del scanner: "+ time.ctime(nmap_report.started) + "</h2></center>"
 
      for k in notAllowed.keys():
         msg_text += "</br><h2>Host: <b>" + k + "</b></h2>"
         msg_text += "<table border=\"3\">"
         msg_text += "<tbody>"
         msg_text +=    "<tr>"
         msg_text +=    "<td> Port </td>"
         msg_text +=    "<td> Protocol </td>"
         msg_text +=    "</tr>"
         for p in notAllowed[k]:
            msg_text +=    "<tr>"
            msg_text +=    "<td>" + str(p[0]) + "</td>"
            msg_text +=    "<td>" + str(p[1]) + "</td>"
            msg_text +=    "</tr>"
         msg_text += "</tbody>"
         msg_text += "</table>"
 
      msg_text += """\
         </body>
       </html>
      """

      msg=MIMEText(msg_text,'html')
      msg['From'] = "vtscanner@voztelecom.net"
      msg['To'] = "adan.alvarez@voztele.com"
      msg['Subject'] = "Scanner"

      try:
          smtpObj = smtplib.SMTP('localhost')
          recipients = ['adan.alvarez@voztele.com']
          smtpObj.sendmail("vtscanner@voztele.com", recipients, msg.as_string())
      except Exception:
          print "Error: unable to send email"  

def main():
    for content in os.listdir("/usr/local/vt-port-scanning/data/reportstocheck/"): 
        file="/usr/local/vt-port-scanning/data/reportstocheck/" + content
        check_opened_ports(NmapParser.parse_fromfile(file))
        newfile="/usr/local/vt-port-scanning/data/checkedreports/" + content
        os.rename(file, newfile)

if __name__ == "__main__":
    main()
